#
# spec file for package apache2-mod_python (Version 3.1.3)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl apache2 apache2-devel apache2-prefork attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs expat file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libapr-util1 libapr-util1-devel libapr1 libapr1-devel libattr libcom_err libgcc libgssapi libmudflap libnscd libstdc++ libstdc++-devel libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch pcre pcre-devel perl permissions popt procinfo procps psmisc pwdutils python python-devel rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           apache2-mod_python
BuildRequires:  apache2-devel pcre-devel python-devel
%define modname mod_python
%define apxs /usr/sbin/apxs2
%define apache apache2
%define apache_libexecdir %(%{apxs} -q LIBEXECDIR)
%define apache_sysconfdir %(%{apxs} -q SYSCONFDIR)
%define apache_includedir %(%{apxs} -q INCLUDEDIR)
%define apache_serverroot %(%{apxs} -q PREFIX)
%define apache_localstatedir %(%{apxs} -q LOCALSTATEDIR)
%define apache_mmn        %(MMN=$(%{apxs} -q LIBEXECDIR)_MMN; test -x $MMN && $MMN)
Version:        3.1.3
Release:        60.9
Summary:        A Python Module for the Apache 2 Web Server
License:        Any permissive, The Apache Software License
Group:          Productivity/Networking/Web/Servers
Requires:       apache2 %{apache_mmn}
%{py_requires}
Conflicts:      mod_python
AutoReqProv:    on
Url:            http://www.modpython.org/
Source:         %{modname}-%{version}.tar.bz2
Patch1:         mod_python-3.1.3-publisher.dif
Patch2:         mod_python-3.1.3-apache-2.2.dif
Patch3:         mod_python-3.1.3-configure.dif
Patch12:        mod_python-3.1.3-bug251211.dif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
mod_python allows embedding Python within the Apache HTTP server for a
considerable boost in performance and added flexibility in designing
Web-based applications.

Apache processes requests in stages (for example: read the request,
parse headers, check access, and so on). These stages can be
implemented by functions called handlers. Traditionally, handlers are
written in C and compiled into Apache modules. mod_python provides a
way to extend Apache functionality by writing Apache handlers in
Python. For a detailed description of the Apache request processing
process, see the Apache API notes.

For most programmers, the request and the authentication handlers
provide everything required. To ease migration from CGI and Httpdapy,
two handlers are provided that simulate these environments, allowing a
user to run scripts under mod_python with (for the most part) no
changes to the code.

mod_python originated from a project called Httpdapy. For a long time,
Httpdapy was not called mod_python because Httpdapy was not meant to be
Apache-specific. Httpdapy was designed to be cross-platform and was
initially written for the Netscape server.

Usage Hints:

To load mod_python into Apache, add it to APACHE_MODULES in
/etc/sysconfig/apache2. The configuration is described in
/usr/share/doc/packages/apache2-mod_python/doc-html/index.html.



Authors:
--------
    Gregory Trubetskoy <grisha@ispol.com>

%debug_package
%prep
%setup -n %{modname}-%{version}
%patch1 -p1
# the following line is obsolete as soon as we have apache 2.2.0 in autobuild.
# it allows building with 2.0 until then.
case $(/usr/sbin/httpd2 -V | head -n 1 | cut -d/ -f2) in 2.2.*)
%patch2 -p1
;;
esac
%patch3
%patch12 -p1
case %_lib in 
	lib) ;;
	*) mv lib %_lib;;
esac
mv configure.in configure.in.t
sed 's@lib/python@%{_lib}/python@' < configure.in.t > configure.in
mv dist/Makefile.in dist/Makefile.in.t
sed -e "s@setup.py install@setup.py install --prefix=%{_prefix} --root=$RPM_BUILD_ROOT@" \
    -e "s@/lib@/%{_lib}@" \
  < dist/Makefile.in.t \
  > dist/Makefile.in
mv dist/setup.py.in dist/setup.py.in.t
sed -e "s@setup.py install@setup.py install --prefix=%{_prefix} --root=$RPM_BUILD_ROOT@" \
    -e "s@/lib@/%{_lib}@" \
  < dist/setup.py.in.t \
  > dist/setup.py.in

%build
autoconf
# RPM_OPT_FLAGS come from apxs2
./configure --with-apxs=`which %{apxs}` --libdir=%{_libdir}
make OPT="$(%{apxs} -q CFLAGS)"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{apache_libexecdir}
make LIBEXECDIR=$RPM_BUILD_ROOT/%{apache_libexecdir} install

%files
%defattr(-,root,root)
%doc COPYRIGHT CREDITS NEWS README doc-html
%{apache_libexecdir}/%{modname}.so
%{py_sitedir}/%{modname}
%changelog
* Mon Sep 03 2007 - poeml@suse.de
- add fix for old security problem, found in 2004 and fixed in
  trunk, but not present in 3.1 releases of mod_python [#251211]
  CVE-2004-2680
* Mon Jan 15 2007 - poeml@suse.de
- the build fix for absent APR_STATUS_IS_SUCCESS wasn't applied
  anymore, after apache was updated.  It was applied only for
  2.2.0, but should be applied for 2.2.x. [#227846]
* Sat Mar 04 2006 - aj@suse.de
- updated to reflect python changes due to #149809
* Mon Jan 30 2006 - poeml@suse.de
- removed libapr-util1-devel from BuildRequires (apache2-devel does
  require it)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Dec 21 2005 - ro@suse.de
- fix quoting problem in configure.in
* Thu Dec 08 2005 - poeml@suse.de
- if building with apache 2.2, remove references to
  obsolete APR_STATUS_IS_SUCCESS
* Wed Oct 05 2005 - dmueller@suse.de
- add norootforbuild
* Fri Feb 11 2005 - poeml@suse.de
- fix CAN-2005-0088 patch [#50324]
* Tue Feb 01 2005 - poeml@suse.de
- fix information leak in publisher handler, CAN-2005-0088 [#50324]
* Tue Jan 25 2005 - poeml@suse.de
- move usage hints from %%post into package description
* Wed Nov 24 2004 - mcihar@suse.de
- use %%{py_sitedir}
* Fri Mar 05 2004 - poeml@suse.de
- update to 3.1.3
- package is now licensed under Apache Software License 2.0
* Tue Feb 10 2004 - poeml@suse.de
- update to 3.0.4, which fixes a vulnerability whereby a specific
  query string processed by mod_python would cause the httpd rocess
  to crash.
- mod_python-3.0.3-python-2.3b1.dif is no longer needed
* Fri Aug 29 2003 - mcihar@suse.cz
- require same python version as it was built with
* Fri Aug 29 2003 - poeml@suse.de
- Conflicts: mod_python (the Apache 1 module) [#29637]
* Mon Jul 28 2003 - poeml@suse.de
- don't explicitely strip binaries since RPM handles it, and may
  keep the stripped information somewhere
- fix mentioned path to documentation
* Fri Jun 06 2003 - poeml@suse.de
- install missing .py files into python's site-packages folder
- fix installation on 64 bit architecture (lib64)
* Fri May 30 2003 - poeml@suse.de
- new package
- in python-2.3b1, LONG_LONG is renamed to PY_LONG_LONG
